unit hiEnumProcess; {      Windows NT }

interface

uses Windows,Messages,Kol,Share,tlhelp32,Debug;

const     
   NORMAL_PRIORITY_CLASS        = $00000020;
   IDLE_PRIORITY_CLASS          = $00000040;
   HIGH_PRIORITY_CLASS          = $00000080;
   REALTIME_PRIORITY_CLASS      = $00000100;
   BELOW_NORMAL_PRIORITY_CLASS  = $00004000;
   ABOVE_NORMAL_PRIORITY_CLASS  = $00008000;
   OBJ_KERNEL_HANDLE            = $00000200;
   
   PROCES_WOW64_INFORMATION     = 26;
   PROCESS_IMAGE_FILE_NAME      = 27;
   SYSTEM_PROCESSES_INFORMATION = 5;
   SE_KERNEL_OBJECT             = 6;   

type
   PPSID = ^PSID;
   PPACL = ^PACL;
   SIZE_T = LONGWORD;
   NTStatus = DWORD;
   PPSECURITY_DESCRIPTOR = ^PSECURITY_DESCRIPTOR;

const  // 
  STATUS_SUCCESS              = NTStatus($00000000);
  STATUS_ACCESS_DENIED        = NTStatus($C0000022);
  STATUS_INFO_LENGTH_MISMATCH = NTStatus($C0000004);

type
  PUnicodeString = ^TUnicodeString;
  TUnicodeString = packed record
    Length: Word;
    MaximumLength: Word;
    Buffer: PWideChar;
  end;

type
  PObjectAttributes = ^TObjectAttributes;
  TObjectAttributes = packed record
    Length: DWORD;
    RootDirectory: THandle;
    ObjectName: PUnicodeString;
    Attributes: DWORD;
    SecurityDescriptor: Pointer;
    SecurityQualityOfService: Pointer;
  end;

type
  PClientID = ^TClientID;
  TClientID = packed record
    UniqueProcess:cardinal;
    UniqueThread:cardinal;
  end;

type
  PPROCESS_BASIC_INFORMATION = ^PROCESS_BASIC_INFORMATION;
  PROCESS_BASIC_INFORMATION = packed record
    ExitStatus: DWORD;
    PebBaseAddress: Pointer;
    AffinityMask: DWORD;
    BasePriority: DWORD;
    uUniqueProcessId: Ulong;
    uInheritedFromUniqueProcessId: Ulong;
  end;

type
  PPROCESS_MEMORY_COUNTERS = ^PROCESS_MEMORY_COUNTERS;
  _PROCESS_MEMORY_COUNTERS = packed record
    cb: DWORD;
    PageFaultCount: DWORD;
    PeakWorkingSetSize: SIZE_T;
    WorkingSetSize: SIZE_T;
    QuotaPeakPagedPoolUsage: SIZE_T;
    QuotaPagedPoolUsage: SIZE_T;
    QuotaPeakNonPagedPoolUsage: SIZE_T;
    QuotaNonPagedPoolUsage: SIZE_T;
    PagefileUsage: SIZE_T;
    PeakPagefileUsage: SIZE_T;
  end;
  PROCESS_MEMORY_COUNTERS = _PROCESS_MEMORY_COUNTERS;
  TProcessMemoryCounters = PROCESS_MEMORY_COUNTERS;
  PProcessMemoryCounters = PPROCESS_MEMORY_COUNTERS;

type
  PVM_COUNTERS = ^VM_COUNTERS;
  VM_COUNTERS = packed record
    PeakVirtualSize,
    VirtualSize,
    PageFaultCount,
    PeakWorkingSetSize,
    WorkingSetSize,
    QuotaPeakPagedPoolUsage,
    QuotaPagedPoolUsage,
    QuotaPeakNonPagedPoolUsage,
    QuotaNonPagedPoolUsage,
    PagefileUsage,
    PeakPagefileUsage: dword;
  end;

  PIO_COUNTERS = ^IO_COUNTERS;
  IO_COUNTERS = packed record
    ReadOperationCount,
    WriteOperationCount,
    OtherOperationCount,
    ReadTransferCount,
    WriteTransferCount,
    OtherTransferCount: LARGE_INTEGER;
  end;

  PSYSTEM_THREADS = ^SYSTEM_THREADS;
  SYSTEM_THREADS = packed record
    KernelTime,
    UserTime,
    CreateTime: LARGE_INTEGER;
    WaitTime: dword;
    StartAddress: pointer;
    ClientId: TClientId;
    Priority,
    BasePriority,
    ContextSwitchCount: dword;
    State: dword;
    WaitReason: dword;
  end;

  PSYSTEM_PROCESSES = ^SYSTEM_PROCESSES;
  SYSTEM_PROCESSES = packed record
    NextEntryDelta,
    ThreadCount: dword;
    Reserved1 : array [0..5] of dword;
    CreateTime,
    UserTime,
    KernelTime: LARGE_INTEGER;
    ProcessName: TUnicodeString;
    BasePriority: dword;
    ProcessId,
    InheritedFromProcessId,
    HandleCount: dword;
    Reserved2: array [0..1] of dword;
    VmCounters: VM_COUNTERS;
    IoCounters: IO_COUNTERS; // Windows 2000 only
    Threads: array [0..0] of SYSTEM_THREADS;
  end;
  
type
   TCB = function: boolean of object;
   ThiEnumProcess = class(TDebug)
   private
      ID: Cardinal;
      PName, FFullPath: string;
      ovi: TOSVersionInfo;
      procEntry: PROCESSENTRY32;
      procedure Enum(CallBack: TCB);
      procedure EnumNT(CallBack: TCB);
      function EnumAll: boolean;
      function FindID: boolean;
      function FindName: boolean;
   public
     _prop_Name: string;
     _prop_TimeOut:integer;

     _data_ID,
     _data_Name,
     _data_AffinityMask,
     _data_PriorityBoost,
     _data_PriorityClass:THI_Event;

     _event_onProcess,
     _event_onTerminateApp,
     _event_onGetPriority,
     _event_onGetProc,
     _event_onGetProcBoost,
     _event_onGetMemoryInfo,
     _event_onGetProcessAccount,
     _event_onFind,
     _event_onNotFind,
     _event_onEndEnum:THI_Event;

   constructor Create;
   procedure _work_doEnum(var _Data: TData; Index: Word);
   procedure _work_doFindID(var _Data: TData; Index: Word);
   procedure _work_doFindName(var _Data: TData; Index: Word);
   procedure _work_doKill(var _Data: TData; Index: Word);
   procedure _work_doTerminateApp(var _Data: TData; Index: Word);   
   procedure _work_doSetPriority(var _Data: TData; Index: Word);
   procedure _work_doSetProc(var _Data: TData; Index: Word);
   procedure _work_doSetProcBoost(var _Data: TData; Index: Word);
   procedure _work_doGetPriority(var _Data: TData; Index: Word);
   procedure _work_doGetMemoryInfo(var _Data: TData; Index: Word);
   procedure _work_doGetProcessAccount(var _Data: TData; Index: Word);
   procedure _work_doGetProc(var _Data: TData; Index: Word);
   procedure _work_doGetProcBoost(var _Data: TData; Index: Word);
   procedure _var_CurrentID(var _Data: TData; Index: Word);
   procedure _var_CurrParentID(var _Data: TData; Index: Word);   
   procedure _var_FileName(var _Data: TData; Index: Word);
   procedure _var_CPUCount(var _Data: TData; Index: Word);
   procedure _var_FullPath(var _Data: TData; Index: Word);
end;

implementation

type
   TQueryFullProcessImageNameA = function(Process: THandle; Flags: DWORD; Buffer: PChar; Size: PDWORD): DWORD; stdcall;
   TGetModuleFileNameExA       = function (hProcess: THandle; hModule: HMODULE;lpFilename: PAnsiChar; nSize: DWORD): DWORD stdcall;
   TGetProcessPriorityBoost    = function(hThread: THandle; var DisablePriorityBoost: Bool): BOOL; stdcall;
   TSetProcessPriorityBoost    = function(hThread: THandle; DisablePriorityBoost: Bool): BOOL; stdcall;
   TGetProcessAffinityMask     = function(hProcess: THandle; var lpProcessAffinityMask, lpSystemAffinityMask: DWORD): BOOL; stdcall;
   TSetProcessAffinityMask     = function(hProcess: THandle; dwProcessAffinityMask: DWORD): BOOL; stdcall;
   TGetProcessMemoryInfo       = function (hProcess: THandle; ppsmemCounters: PPROCESS_MEMORY_COUNTERS; cb: DWORD): BOOL; stdcall;
   TZwOpenProcess              = function(phProces: PDWORD; AccessMask: DWORD; ObjectAttributes: PObjectAttributes; ClientID: PClientID): NTStatus; stdcall;
   TZwTerminateProcess         = function(ProcessHandle: dword; ExitStatus: dword):NTStatus; stdcall;
   TGetSecurityInfo            = function(Handle: THandle; ObjectType: DWORD; SecurityInfo: SECURITY_INFORMATION; ppsidOwner, ppsidGroup: PPSID;
                                          ppDacl, ppSacl: PPACL; var ppSecurityDescriptor:  PSecurityDescriptor): DWORD; stdcall;
   TZwQuerySystemInformation   = function(ASystemInformationClass: DWORD; ASystemInformation: Pointer; ASystemInformationLength: DWORD;
                                          AReturnLength: PDWORD): NTStatus; stdcall;

var
   hPSAPI, hNTDLL, hADVAP, hKRNL  : THandle;   
   GetProcessMemoryInfo           : TGetProcessMemoryInfo;
   GetSecurityInfo                : TGetSecurityInfo;
   ZwOpenProcess                  : TZwOpenProcess;
   ZwTerminateProcess             : TZwTerminateProcess;
   ZwQuerySystemInformation       : TZwQuerySystemInformation;
   GetProcessPriorityBoost        : TGetProcessPriorityBoost;
   SetProcessPriorityBoost        : TSetProcessPriorityBoost;
   GetProcessAffinityMask         : TGetProcessAffinityMask;
   SetProcessAffinityMask         : TSetProcessAffinityMask;
   GetModuleFileNameEx            : TGetModuleFileNameExA;
   QueryFullProcessImageNameA     : TQueryFullProcessImageNameA;
//**********************************************************************************

function Trim(const Str : string): string;
var
  L: integer;
begin
  Result := Str;
  L := Length(Result);
  while (L > 0) and (Result[L] <= ' ') do Dec(L);
  SetLength(Result, L);
  L := 1;
  while (L <= Length(Result)) and (Result[L] <= ' ') do Inc(L);
  Result := string(PChar(integer(@Result[1]) + L - 1)); 
end;

function WideStringToString(const ws: WideString): String;
var
  l: integer;
begin
  if ws = '' then
    Result := ''
  else
  begin
    l := WideCharToMultiByte(CP_ACP, 0, PWChar(ws), -1, nil, 0, nil, nil);
    SetLength(Result, l - 1);
    if l > 1 then
      WideCharToMultiByte(CP_ACP, 0, PWChar(ws), -1, PChar(Result), l - 1, nil, nil);
  end;
end;

//**********************************************************************************

constructor ThiEnumProcess.Create;
var
  hToken: THandle;
  TokenPriv, PrevTokenPriv: TOKEN_PRIVILEGES;
  Tmp: Cardinal;
begin
  inherited;
  FillChar(ovi, SizeOf(TOSVersionInfo), #0); 
  ovi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  GetVersionEx(ovi);
  if hPSAPI = 0 then
  begin
    hPSAPI := LoadLibrary('psapi.dll');
    @GetProcessMemoryInfo   := GetProcAddress(hPSAPI, 'GetProcessMemoryInfo');
    if ovi.dwMajorVersion < 6 then
      @GetModuleFileNameEx    := GetProcAddress(hPSAPI, 'GetModuleFileNameExA');
  end;
  if hNTDLL = 0 then
  begin
    hNTDLL := LoadLibrary('ntdll.dll');
    @ZwOpenProcess             := GetProcAddress(hNTDLL, 'ZwOpenProcess');
    @ZwTerminateProcess        := GetProcAddress(hNTDLL, 'ZwTerminateProcess'); 
    @ZwQuerySystemInformation  := GetProcAddress(hNTDLL, 'ZwQuerySystemInformation');
  end;
  if hADVAP = 0 then
  begin
    hADVAP := LoadLibrary(advapi32);
    @GetSecurityInfo := GetProcAddress(hADVAP, 'GetSecurityInfo');
  end;
  if hKRNL = 0 then
  begin
    hKRNL := LoadLibrary(kernel32);
    @GetProcessPriorityBoost    := GetProcAddress(hKRNL, 'GetProcessPriorityBoost');
    @SetProcessPriorityBoost    := GetProcAddress(hKRNL, 'SetProcessPriorityBoost');
    @GetProcessAffinityMask     := GetProcAddress(hKRNL, 'GetProcessAffinityMask');
    @SetProcessAffinityMask     := GetProcAddress(hKRNL, 'SetProcessAffinityMask');
    @QueryFullProcessImageNameA := GetProcAddress(hKRNL, 'QueryFullProcessImageNameA');
  end;

  OpenProcessToken(GetCurrentProcess, MAXIMUM_ALLOWED, hToken);
  TokenPriv.PrivilegeCount := 1;
  TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  LookupPrivilegeValue(nil, 'SeDebugPrivilege', TokenPriv.Privileges[0].Luid);
  Tmp := 0;
  PrevTokenPriv := TokenPriv;
  AdjustTokenPrivileges(hToken, False, TokenPriv, SizeOf(PrevTokenPriv), PrevTokenPriv, Tmp);
  CloseHandle(hToken);
end;

function GetProcessAccount(proc: THandle): string;
var
  sd: PSecurityDescriptor;
  snu: SID_NAME_USE;
  DomainName, UserName: string;
  UserNameSize, DomainNameSize: cardinal;
  sid: PSid;
begin
  Result := '';
  if GetSecurityInfo(proc, SE_KERNEL_OBJECT, OWNER_SECURITY_INFORMATION, @sid, nil, nil, nil, sd) = ERROR_SUCCESS then
  begin
    UserNameSize := 1024;
    DomainNameSize := 1024;
    SetLength(UserName, UserNameSize);
    SetLength(DomainName, DomainNameSize);
    FillChar(UserName[1], UserNameSize, #0);
    FillChar(DomainName[1], DomainNameSize, #0);         

    if LookupAccountSid(nil, sid, @UserName[1], UserNameSize, @DomainName[1], DomainNameSize, snu) then
      Result := Trim(UserName);  
    LocalFree(Integer(sd));
  end;
end;

function EnumWindowsProc(Wnd: HWND; ProcessID: DWORD): Boolean; stdcall;
var
  PID: DWORD;
begin
  GetWindowThreadProcessId(Wnd, @PID);
  if ProcessID = PID then
    PostMessage(Wnd, WM_CLOSE, 0, 0);
  Result := True;
end;

function TerminateApp(ProcessID: DWORD; Timeout: DWORD): Integer;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
begin
  Result := -1;
  if ProcessID = GetCurrentProcessId then exit;
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := ProcessID;
  hProcess := 0;
TRY  
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  EnumWindows(@EnumWindowsProc, Lparam(ProcessID));
  if WaitForSingleObject(hProcess, Timeout) = WAIT_OBJECT_0 then
    Result := 0
  else if ZwTerminateProcess(hProcess, 1) = NO_ERROR then Result := 1;
FINALLY
  CloseHandle(hProcess);
END;    
end;

procedure ThiEnumProcess._work_doTerminateApp;
begin
  _hi_onEvent(_event_onTerminateApp, TerminateApp(procEntry.th32ProcessID, _prop_TimeOut)); 
end;

procedure ThiEnumProcess._work_doKill;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;  
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) = NO_ERROR then
    ZwTerminateProcess(hProcess, 1);
  CloseHandle(hProcess);
end;

{      }
Function GetInfoTable(ATableType:dword):Pointer;
var
  mSize: dword;
  mPtr: pointer;
  St: NTStatus;
begin
  Result := nil;
  mSize := $4000; //  

  repeat
    mPtr := VirtualAlloc(nil, mSize, MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
    if mPtr = nil then Exit;
    St := ZwQuerySystemInformation(ATableType, mPtr, mSize, nil);
    if St = STATUS_INFO_LENGTH_MISMATCH then
    begin //  
      VirtualFree(mPtr, 0, MEM_RELEASE);
      mSize := mSize * 2;
    end;
  until St <> STATUS_INFO_LENGTH_MISMATCH;
  if St = STATUS_SUCCESS then
    Result := mPtr
  else
    VirtualFree(mPtr, 0, MEM_RELEASE);
end;

procedure ThiEnumProcess.EnumNT;
var
  hProcess: THandle;
  info, info2: PSystem_Processes;
  process_name: String;
  process_name_unicode: TUnicodeString;
  pwch: String;    
  OA: TObjectAttributes;
  CID: TClientID;
  S: DWORD;
  FPart: string;
begin

  info := GetInfoTable(SYSTEM_PROCESSES_INFORMATION);
TRY
  info2 := info;
  while (info2^.NextEntryDelta <> 0) do
  begin
    procEntry.th32ProcessID := info2^.ProcessId;
    procEntry.th32ParentProcessID := info2^.InheritedFromProcessId;    
    process_name_unicode := info2^.ProcessName;

    process_name := '';
    if process_name_unicode.Length <> 0 then
    begin 
      SetLength(pwch, process_name_unicode.Length);  
      process_name := Trim(WideStringToString(process_name_unicode.Buffer));
    end;

    FillChar(OA, SizeOf(OA), #0);
    OA.Attributes := OBJ_KERNEL_HANDLE;
    CID.UniqueThread := 0;
    CID.UniqueProcess := procEntry.th32ProcessID;
    hProcess := 0;

    if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) = NO_ERROR then
    begin
      S := SizeOf(procEntry.szExeFile);
      if ovi.dwMajorVersion < 6 then
        GetModuleFilenameEx(hProcess, 0, procEntry.szExeFile, S)
      else
        QueryFullProcessImageNameA(hProcess, 0, procEntry.szExeFile, @S);
  end;  
    CloseHandle(hProcess);
 
    FPart := ExtractFileExt(string(procEntry.szExeFile));
    delete(FPart, 1, 1); 
    if FPart = '' then
    begin
      FillChar(procEntry.szExeFile, SizeOf(procEntry.szExeFile), #0);    
      Move(process_name[1], procEntry.szExeFile, length(process_name));
    end;  

    if not CallBack() then exit;
    info2 := Pointer(dword(info2)+info2^.NextEntryDelta);
  end;
FINALLY
  VirtualFree(info, 0, MEM_RELEASE);
  _hi_OnEvent(_event_onEndEnum);
END;  
end;

procedure ThiEnumProcess.Enum;
begin
  if ovi.dwMajorVersion < 5 then exit;
  EnumNT(CallBack);
end;

function ThiEnumProcess.EnumAll;
begin
  if procEntry.szExeFile <> '' then
    _hi_OnEvent(_event_onProcess, procEntry.szExeFile);
  Result := true;
end;

procedure ThiEnumProcess._work_doEnum;
begin
  Enum(EnumAll);
  FillChar(procEntry, sizeof(procEntry), 0);
end;

function ThiEnumProcess.FindID;
begin
  Result := ID <> procEntry.th32ProcessID;
end;

procedure ThiEnumProcess._work_doFindID;
begin
  ID := ReadInteger(_Data, _data_ID, 0);
  Enum(FindID);
  if ID = procEntry.th32ProcessID then
  begin
    FFullPath := procEntry.szExeFile;
    _hi_CreateEvent(_Data, @_event_onFind);
  end   
  else
  begin
    FFullPath := '';
    _hi_CreateEvent(_Data, @_event_onNotFind);
  end;
end;

function ThiEnumProcess.FindName;
begin
  Result := PName <> ExtractFileName(LowerCase(procEntry.szExeFile));
end;

procedure ThiEnumProcess._work_doFindName;
begin
  PName := LowerCase(ReadString(_Data,_data_Name,_prop_Name));
  Enum(FindName);
  if PName = ExtractFileName(LowerCase(procEntry.szExeFile)) then
  begin
    FFullPath := procEntry.szExeFile; 
    _hi_CreateEvent(_Data,@_event_onFind);
  end   
  else
  begin
    FFullPath := '';
    _hi_CreateEvent(_Data,@_event_onNotFind);
  end;   
end;

procedure ThiEnumProcess._work_doGetPriority;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  pc: Cardinal;
  Priority: Integer;
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;  
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  Priority := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  pc := integer(GetPriorityClass(hProcess));
  case pc of
    NORMAL_PRIORITY_CLASS       : Priority := 0;
    IDLE_PRIORITY_CLASS         : Priority := 1;
    HIGH_PRIORITY_CLASS         : Priority := 2;
    REALTIME_PRIORITY_CLASS     : Priority := 3;
    BELOW_NORMAL_PRIORITY_CLASS : Priority := 4;
    ABOVE_NORMAL_PRIORITY_CLASS : Priority := 5;
  end;
FINALLY
  CloseHandle(hProcess);
  _hi_CreateEvent(_Data, @_event_onGetPriority, Priority);
END;  
end;

procedure ThiEnumProcess._work_doGetProc;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  lpProcessAffinityMask, lpSystemAffinityMask: dword;
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;  
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  GetProcessAffinityMask(hProcess, lpProcessAffinityMask, lpSystemAffinityMask);
FINALLY
  CloseHandle(hProcess);
  _hi_CreateEvent(_Data, @_event_onGetProc, {$ifdef F_P}integer{$endif}(lpProcessAffinityMask));
END;  
end;

procedure ThiEnumProcess._work_doGetMemoryInfo;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  pmc: TProcessMemoryCounters;
  WorkingSetSize: integer;  
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  WorkingSetSize := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  if GetProcessMemoryInfo(hProcess, @pmc, sizeof(TProcessMemoryCounters)) then
    WorkingSetSize := {$ifdef F_P}integer{$endif}(pmc.WorkingSetSize); 
FINALLY
  CloseHandle(hProcess);
  _hi_CreateEvent(_Data, @_event_onGetMemoryInfo, WorkingSetSize);
END;  
end;

procedure ThiEnumProcess._work_doGetProcessAccount;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  ProcessAccount: string;  
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  ProcessAccount := '';  
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  ProcessAccount := GetProcessAccount(hProcess); 
FINALLY
  CloseHandle(hProcess);
  _hi_CreateEvent(_Data,@_event_onGetProcessAccount, ProcessAccount);
END;  
end;

procedure ThiEnumProcess._work_doGetProcBoost;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  DisablePriorityBoost: Bool;
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
  DisablePriorityBoost := true;  
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  GetProcessPriorityBoost(hProcess, DisablePriorityBoost);
FINALLY
  CloseHandle(hProcess);
  if DisablePriorityBoost then
    _hi_CreateEvent(_Data, @_event_onGetProcBoost, 0)
  else
    _hi_CreateEvent(_Data, @_event_onGetProcBoost, 1);
END;  
end;

procedure ThiEnumProcess._work_doSetPriority;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  pc: Cardinal;
begin
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  case Readinteger(_Data, _data_PriorityClass, 0) of
    0: pc := NORMAL_PRIORITY_CLASS;
    1: pc := IDLE_PRIORITY_CLASS;
    2: pc := HIGH_PRIORITY_CLASS;
    3: pc := REALTIME_PRIORITY_CLASS;
    4: pc := BELOW_NORMAL_PRIORITY_CLASS;
    5: pc := ABOVE_NORMAL_PRIORITY_CLASS;
    else pc := NORMAL_PRIORITY_CLASS;
  end;
  SetPriorityClass(hProcess, pc);
FINALLY
  CloseHandle(hProcess);
END;  
end;

procedure ThiEnumProcess._work_doSetProc;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  pc: byte;
begin
  pc := Readinteger(_Data,_data_AffinityMask,0);
  if pc = 0 then Exit;
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  SetProcessAffinityMask(hProcess, pc);
FINALLY
  CloseHandle(hProcess);
END;  
end;

procedure ThiEnumProcess._work_doSetProcBoost;
var
  hProcess: THandle;
  OA: TObjectAttributes;
  CID: TClientID;
  pc: byte;
  DisablePriorityBoost:bool;
begin
  pc := Readinteger(_Data,_data_PriorityBoost,0);
  DisablePriorityBoost := not boolean(pc);
  FillChar(OA, SizeOf(OA), #0);
  OA.Attributes := OBJ_KERNEL_HANDLE;
  CID.UniqueThread := 0;
  CID.UniqueProcess := procEntry.th32ProcessID;
  hProcess := 0;
TRY
  if ZwOpenProcess(@hProcess, PROCESS_ALL_ACCESS, @OA, @CID) <> NO_ERROR then exit;
  SetProcessPriorityBoost(hProcess, DisablePriorityBoost);
FINALLY
  CloseHandle(hProcess);
END;  
end;

procedure ThiEnumProcess._var_CurrentID;
begin
  dtInteger(_Data, procEntry.th32ProcessID);
end;

procedure ThiEnumProcess._var_CurrParentID;
begin
  dtInteger(_Data, procEntry.th32ParentProcessID);
end;

procedure ThiEnumProcess._var_FileName;
begin
  dtString(_Data, procEntry.szExeFile);
end;

procedure ThiEnumProcess._var_CPUCount;
var
  lpSystemInfo: _SYSTEM_INFO;
begin
  GetSystemInfo(lpSystemInfo);
  dtInteger(_Data, lpSystemInfo.dwNumberOfProcessors);
end;

procedure ThiEnumProcess._var_FullPath;
begin
  dtString(_Data, FFullPath);
end;

end.